package net.zmobile.ui;

import java.util.Vector;

import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Graphics;

import net.zmobile.ZMobile;
import net.zmobile.ge.ZPoint;
import net.zmobile.ge.ZRect;

public abstract class ZComponent {
	int _x = 0;
	int _y = 0;
	int _w = -1;
	int _h = -1;

	Font _font = null;
	String _text = "";
	int _color = 0xffffff;

	protected boolean isFoucus = false;
	protected boolean isCanFoucus = true;
	protected boolean isPressed = false;

	Vector listeners = null;
	Vector listenerTypes = null;

	// new Vector();
	public Vector getListeners() {
		if (listeners == null) {
			listeners = new Vector();
		}

		return listeners;
	}

	public Vector getListenersTypes() {
		if (listenerTypes == null) {
			listenerTypes = new Vector();
		}

		return listenerTypes;
	}

	public void addListener(byte type, Listener listener) {
		getListenersTypes().addElement(new Byte(type));
		getListeners().addElement(listener);
	}

	public boolean isCanFoucus() {
		return isCanFoucus;
	}

	public boolean isFoucus() {
		return isFoucus;
	}

	public void setFoucus(boolean foucus) {
		isFoucus = foucus;
	}

	public boolean isPressed() {
		return isPressed;
	}

	public void setPressed(boolean isPressed) {
		this.isPressed = isPressed;
	}

	public void setBounds(int x, int y, int w, int h) {
		_x = x;
		_y = y;
		if (w >= 0) {
			_w = w;
		}
		if (h >= 0) {
			_h = h;
		}
	}

	public abstract void draw(Graphics g);

	public void redraw(Graphics g) {
		g.setClip(_x + ZMobile.GRAP, _y + ZMobile.GRAP, _w - ZMobile.GRAP, _h
				- ZMobile.GRAP);
		draw(g);
		drawStatus(g);
	}

	public abstract void drawStatus(Graphics g);

	public Font getFont() {
		return _font;
	}

	public void setFont(Font font) {
		this._font = font;
	}

	public String getText() {
		return _text;
	}

	public void setText(String _text) {
		this._text = _text;
	}

	public int getColor() {
		return _color;
	}

	public void setColor(int _color) {
		this._color = _color;
	}

	public void firePointRelease(ZPoint point) {
		setPressed(false);
		fireEvent(ZMobile.EVENT_POINTER_RELEASED, point.x, point.y,
				0);
	}

	public void firePointPressed(ZPoint point) {
		ZRect rect = new ZRect(_x, _y, _w, _h);
		if (rect.contains(point)) {
			setFoucus(true);
			setPressed(true);
		} else {
			setFoucus(false);
			setPressed(false);
		}
		fireEvent(ZMobile.EVENT_POINTER_PRESS, point.x, point.y, 0);
	}

	public void fireSelectedRelease() {
		if (this.isFoucus) {
			setPressed(false);
			fireEvent(ZMobile.EVENT_KEY_SELECT_RELESE, 0, 0, 0);
		}
	}

	public void fireSelectedPressed() {
		if (this.isFoucus) {
			setPressed(true);
			fireEvent(ZMobile.EVENT_KEY_SELECT, 0, 0, 0);
		}
	}

	private void fireEvent(int type,int x,int y,int key) {
		if (listeners != null) {
			for (int index = 0; index < listeners.size(); index++) {
				if ((type == ((Byte) listenerTypes.elementAt(index))
						.byteValue())) {
					((Listener) listeners.elementAt(index)).event(x,y,key);
				}
			}
		}
	}

	public int getX() {
		return _x;
	}

	public void setX(int x) {
		this._x = x;
	}

	public int getY() {
		return _y;
	}

	public void setY(int y) {
		this._y = y;
	}

	public int getWidth() {
		return _w;
	}

	public void setWidth(int w) {
		this._w = w;
	}

	public int getHeight() {
		return _h;
	}

	public void setHeight(int h) {
		this._h = h;
	}
	
	public abstract void resetSize();
}
