package net.zmobile.ui;

import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;

import net.zmobile.ZMobile;
import net.zmobile.ge.ZPoint;
import net.zmobile.ge.ZRect;

class ZFormCanvas extends Canvas implements Runnable {

	Image img = null;
	ZForm _form = null;

	public ZFormCanvas(ZForm form) {
		_form = form;
	}

	protected void paint(Graphics g) {
		if (img == null)
			img = Image.createImage(_form.getWidth(), _form.getHeight());

		Graphics tmpg = img.getGraphics();
		tmpg.setColor(0xffffff);
		tmpg.fillRect(0, 0, _form.getWidth(), _form.getHeight());
		for (int t = 0; t < ZForm.uiStack.size(); t++) {
			ZContainer container = (ZContainer) ZForm.uiStack.elementAt(t);
			container.redraw(tmpg);
		}

		drawTitle(tmpg);
		drawSoftKey(tmpg);
		g.drawImage(img, _form.getX(), _form.getY(), Graphics.TOP | Graphics.LEFT);
	}

	protected void drawTitle(Graphics g) {
		if (_form.getTitle() == null || _form.getTitle().equals(""))
			return;
		g.setClip(0, 0, _form.getWidth() + 1, ZConstants.TILTE_HEIGHT + 1);

		g.setColor(ZConstants.TILTE_BACK_COLOR);
		g.fillRect(0, 0, _form.getWidth(), ZConstants.TILTE_HEIGHT);

		g.setColor(0);
		g.drawLine(0, ZConstants.TILTE_HEIGHT, _form.getWidth(), ZConstants.TILTE_HEIGHT);

		g.setColor(ZConstants.TILTE_FORE_COLOR);
		g.drawString(_form.getText(), 2, 0, Graphics.TOP | Graphics.LEFT);
	}

	protected void drawSoftKey(Graphics g) {
		g.setClip(0, _form.getHeight() - ZConstants.FOOTER_HEIGHT, _form.getWidth() + 1,
				ZConstants.FOOTER_HEIGHT + 1);

		g.setColor(ZConstants.FOOTER_BACK_COLOR);
		g.fillRect(0, _form.getHeight() - ZConstants.FOOTER_HEIGHT, _form.getWidth(), _form.getHeight()
				- ZConstants.FOOTER_HEIGHT);

		g.setColor(0);
		g.drawLine(0, _form.getHeight() - ZConstants.FOOTER_HEIGHT, _form.getWidth(), _form.getHeight()
				- ZConstants.FOOTER_HEIGHT);

		g.setColor(ZConstants.FOOTER_FORE_COLOR);
		// g.drawString(_title, 0, 0, Graphics.TOP| Graphics.LEFT);
	}
	public static Object mainThreadMetux = new Object();
	public static Object dialogMetux = new Object();
	protected void pointerReleased(int i, int j) {
		super.pointerPressed(i, j);
		ZPoint point = new ZPoint(i, j);
		ZContainer container = (ZContainer) ZForm.uiStack.peek();
		ZRect rect = new ZRect(container._x, container._y, container._w,
				container._h);
		if (rect.contains(point)) {
			container.firePointRelease(point);
		} else {
			if (container instanceof ZMenu)
				ZForm.uiStack.pop();
		}
		_keyCode = -5;
		try {
			new Thread(this).start();
			synchronized (mainThreadMetux) {
				mainThreadMetux.wait();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		this.repaint();
	}

	int _keyCode = 0;

	protected void keyReleased(int keyCode) {
		super.keyReleased(keyCode);
		this._keyCode = keyCode;
		try {
			new Thread(this).start();
			synchronized (mainThreadMetux) {
				mainThreadMetux.wait();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		this.repaint();
	}

	protected void pointerPressed(int i, int j) {
		super.pointerPressed(i, j);
		ZPoint point = new ZPoint(i, j);
		ZContainer container = (ZContainer) ZForm.uiStack.peek();
		ZRect rect = new ZRect(container._x, container._y, container._w,
				container._h);
		if (rect.contains(point)) {
			container.firePointPressed(point);
		} else {
			if (container instanceof ZMenu)
				ZForm.uiStack.pop();
		}
		this.repaint();
	}

	protected void keyPressed(int keyCode) {
		super.keyPressed(keyCode);
		ZContainer container = (ZContainer) ZForm.uiStack.peek();
		switch (keyCode) {
		case Canvas.UP:
			break;
		case Canvas.DOWN:
			break;
		case Canvas.LEFT:
			break;
		case Canvas.RIGHT:
			break;
		case -5:
			container.fireSelectedPressed();
			container = null;
			break;
		case -6:
			break;
		case -7:
			break;
		}

		this.repaint();
	}

	public void run() {
		ZContainer container = (ZContainer) ZForm.uiStack.peek();
		switch (_keyCode) {
		case Canvas.UP:
			break;
		case Canvas.DOWN:
			break;
		case Canvas.LEFT:
			break;
		case Canvas.RIGHT:
			break;
		case -5:
			container.fireSelectedRelease();
			break;
		case -6:
//			_menu.setBounds(1, ZForm.this._client_h + ZConstants.TILTE_HEIGHT
//					- _menu.getHeight(), -1, -1);
//			_menu.show(ZMenu.LEFT_KEY);
			break;
		case -7:
//			_menu.setBounds(1, ZForm.this._client_h + ZConstants.TILTE_HEIGHT
//					- _menu.getHeight(), -1, -1);
//			_menu.show(ZMenu.RIGTH_KEY);
			break;
		}
		if (container.listeners != null) {
			for (int i = 0; i < container.listeners.size(); i++) {
				if ((ZMobile.EVENT_KEY_RELEASED == ((Byte) container.listenerTypes
						.elementAt(i)).byteValue())) {
					((Listener) container.listeners.elementAt(i)).event(0, 0,
							_keyCode);
				}
			}
		}
		if (!(container instanceof ZDialog)) {
			try {
				synchronized (mainThreadMetux) {
					mainThreadMetux.notify();
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		if ((container.equals(ZForm.uiStack.peek()))) {
			try {
				synchronized (mainThreadMetux) {
					mainThreadMetux.notify();
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		container = null;
	}

}
